<template>
  <div class="app-collection grouped">
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="ac__header">
      <!-- @slot Use this slot for header -->
      <slot name="header"></slot>
    </header>

    <main class="ac__body container-fluid">
      <div
        v-for="(value, key) in data"
        :key="key"
        class="ac__item"
      >
        <div class="group-header">
          <!-- @slot Use this slot group_header for each item in response -->
          <slot name="group_header" :title="key"></slot>
        </div>

        <div class="ac__item__body">
          <!-- @slot Use this slot body for each item in response -->
          <slot name="body" :data="value"></slot>
        </div>

         <!-- @slot Use this slot group_footer for each item in response -->
         <div class="group-footer">
          <slot name="group_footer"></slot>
         </div>
      </div>
    </main>

    <div
      v-show="load_more_type === 'loadMoreButton'"
      ref="loader_div"
      class="load-more text-center mt-2"
    >
      <!-- @slot Slot for load more buttom, shown only if load_more_type is 'loadMoreButton' -->
      <slot name="load_more_button"></slot>
    </div>

    <footer class="ac__footer">
      <!-- @slot Use this slot for footer -->
      <slot name="footer"></slot>
    </footer>
  </div>
</template>

<script>
import AppCollection from './ac-collection.vue'
/**
 * ac Grouped component which can be used to display items in grid, accordion, table
 * @requires VueBootstrap
 * @requires ac-collection.vue
 */
export default {
  name: 'ac-collection-grouped',

  extends: AppCollection,

  props: {
    /**
     * @param {string} group_key - Data from every request will be grouped with this key
     * Required
     */
    group_key: {
      type: String,
      required: true,
    },
  },
}
</script>

<style scoped>
.ac__item {
  flex-direction: column;
}

.loader {
  position: fixed;
  display: flex;
  align-items: center;
  justify-content: center;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 999;
  background-color: rgba(255, 255, 255, .65);
}
</style>
